% General documentation 
% Helfer Thomas; Jean-Michel Proix
% August 19, 2014

# References

- general introduction. Material properties and Models: [mfront.pdf](documents/mfront/mfront.pdf)
- writing mechanical behaviours: [behaviours.pdf](documents/mfront/behaviours.pdf)
- how to handle plane stress in implicit schemes: [planestress.pdf](documents/mfront/planestress.pdf)
- finite strain behaviours [finitestrain.pdf](documents/mfront/finitestrain.pdf)
<!-- - mtest user guide: [mtest.pdf](documents/mtest/mtest.pdf) -->

# Tutorials

- [tutoriel.pdf](documents/tutoriel/tutoriel.pdf)

# Courses

- general introduction: [mfront-presentation.pdf](documents/mfront-presentation/mfront-presentation.pdf)
- writing mechanical behaviours [mfront-behaviours.pdf](documents/mfront-behaviours/mfront-behaviours.pdf)
- general introduction [mfront-formation.pdf](documents/mfront-formation/mfront-formation.pdf)
    - [tp.pdf](documents/tp/tp.pdf)

# Talks

- finite strain: [mfront-finitestrain.pdf](documents/mfront-finitestrain/mfront-finitestrain.pdf)
- [mfront user meeting](documents/mfront-user-meeting-2015/mfront.html)
- [writing portable behaviours](documents/portable-behaviour/portability.html)
- introduction to MFront (talk given at Materiaux 2014 in Montpellier): [materiaux2014.html](documents/Materiaux2014/materiaux2014.html)
- several applications of MFront to describe elasto-plasticity at
  finite strains (talk given at the
  [`Cast3M`](http://www-cast3m.cea.fr) user meeting on November, 28
  2014: [HureCast3M14.pdf](documents/ClubCast3M2014/HureCast3M14.pdf)
<!-- - mtest: [mtest.pdf](documents/mtest-presentation/mtest-presentation.pdf) -->


# Solver interfaces

- interface of the [Cast3M](http://www-cast3m.cea.fr) finite element
  solver [umat.pdf](documents/mfront/umat.pdf);
- interface of the [Code-Aster](http://www.code-aster.org) finite
  element solver [aster.pdf](documents/mfront/aster.pdf);
- interface of the
  [ZeBuLoN](http://www.zset-software.com/products/zebulon) finite
  element solver [zmat.pdf](documents/mfront/zmat.pdf);

<!-- Local IspellDict: english -->
