/*! 
 * \file  include/TFEL/Math/Forward/vector.hxx
 * \brief
 * \author Helfer Thomas
 * \brief 19 sept. 2011
 * \copyright Copyright (C) 2006-2014 CEA/DEN, EDF R&D. All rights 
 * reserved. 
 * This project is publicly released under either the GNU GPL Licence 
 * or the CECILL-A licence. A copy of thoses licences are delivered 
 * with the sources of TFEL. CEA or EDF may also distribute this 
 * project under specific licensing conditions. 
 */

#ifndef _LIB_TFEL_MATH_FORWARD_VECTOR_H_
#define _LIB_TFEL_MATH_FORWARD_VECTOR_H_ 

namespace tfel
{

  namespace math
  {

    /*!
     * \class vector
     * \brief  A class representing resizable medium sized vector.
     * \param  ValueType, the underlying numerical type.
     * \author Helfer Thomas
     * \date   04 April 2007
     */
    template<typename T>
    class vector;

  } // end of namespace math

} // end of namespace tfel

#endif /* _LIB_TFEL_MATH_FORWARD_VECTOR_H */

